'************************************************
' File:    Lista file Mp3.vbs
' Autore:  Giovanni Cenati 
' http://digilander.libero.it/Cenati
' Codice liberamente utilizzabile citando il sito.
' Crea in excel una lista dei files Mp3	con alcuni dati aggiuntivi.
' Creates an excel file with a list of Mp3 files and some additional data.
' 2004/11/02
'************************************************
Set Player = createobject("wmplayer.ocx.7")
Set fso = CreateObject("Scripting.FileSystemObject")
set oXL = WScript.CreateObject("Excel.Application")
oXL.Visible = TRUE
oXL.WorkBooks.Add

'drive= inputbox ("Scan which drive?","List of Mp3 files - Cenati Giovanni","C:\")
drive= inputbox ("Nome del drive in cui cercare:","Lista files Mp3 - Cenati Giovanni","C:\")
Mp3List= GetListOfMp3Files(drive)
songslist = Split(Mp3List, vbCrLf) 'Creates an array of the lines of the file
Mp3List=""

dim attr(10)
attr(1)= "Artist"
attr(2)= "Album"
attr(3)= "Author"
attr(4)= "Bitrate"
attr(5)= "CreationDate"
attr(6)= "Genre"

' Column Headers - Intestazioni delle colonne
oXL.cells(1,1)="File Name"
oXL.cells(1,2)="Name"
oXL.cells(1,3)="Durata(secondi)"
oXL.cells(1,4)="Durata(min,sec)"
for i= 1 to ubound(attr)
    oXL.cells(1,4+i)=attr(i)
next
oXL.cells(1,11)="File size"
oXL.cells(1,12)="File date"

on error resume next 'for song names with accents 
for songnumber=0 to ubound(songslist)
    row=songnumber+2
    player.mediaCollection.add(songslist(songnumber))
    player.url=songslist(songnumber)

    oXL.cells(row,1)= songslist(songnumber)
    oXL.cells(row,2)= player.currentmedia.name
    oXL.cells(row,3)= player.currentmedia.duration
    oXL.cells(row,4)= player.currentmedia.durationstring
    for a=1 to 6
        oXL.cells(row,4+a)= player.currentMedia.getItemInfobyAtom(player.mediaCollection.getMediaAtom(attr(a)))
    next
    set f = fso.GetFile(songslist(songnumber))
    oXL.cells(row,11)= f.size
    oXL.cells(row,12)= f.DateCreated

    wscript.sleep 60 'Altrimenti si blocca - Otherwise it hangs
next
oxl.cells(1,1).select
set oXl=nothing
msgbox "End of job - Cenati Giovanni"  ,,"List of Mp3 Files"

function GetListOfMp3Files(drive)
 dim fso, tmp, wshshell, ofile, path
 cmd = "dir "& trim(drive) & "*.mp3 /s/b "   ' Comando DOS
 Const tmpFolder=2
 Set fso = CreateObject("Scripting.FileSystemObject")
 ' Chiede al sistema un nome di file temporaneo.
 ' Asks Windows a unique temporary file name
 tmp = fso.GetTempName
 ' Recupera il path del file temporaneo.
 ' Gets the complete path of the temp file
 path = fso.GetSpecialFolder(tmpFolder)
 tmp = path & "\" & tmp     ' Questo  il pathname completo del file tmp.
 ' Crea un oggetto WshShell... Creates the needed wshell object
 Set WshShell = CreateObject("WScript.Shell")
 ' Esegue il comando dos e redirige l'output sul file tmp 
 ' Executes dos command and redirects the output on the tmp file
 WSHShell.Run "%comspec% /c " & cmd & " >" & tmp, 0, True
 ' Legge il contenuto del file. Reads the content
 Set oFile = fso.OpenTextFile(tmp)
 GetListOfMp3Files = oFile.ReadAll
 oFile.Close  'lo chiude - Closes the file
 fso.DeleteFile tmp   ' e lo cancella - and deletes it
end function
' *** End ***
